=== debian/changelog ===
magit (3.3.0-3) unstable; urgency=medium

  [ Aymeric Agon-Rambosson ]
  * Repair watch file.

  [ Xiyue Deng ]
  * Reformat Build-Depends to list one per line in alphabetic order to
    make further changes easier to track.
  * Fix `make test` failure.  Closes: #1042289.
    - Add elpa-compat to Build-Depends.
    - Cherrypick upstream patch partially to detect compat in LOAD_PATH.
  * Update Standards-Version to 4.6.2.  No change needed.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 29 Jul 2023 10:24:44 +0100

magit (3.3.0-2) unstable; urgency=medium

  [ Aymeric Agon-Rambosson ]
  * Add myself, Aymeric Agon-Rambosson, to Uploaders.
  * Add repair-magit-get-and-submodule-tests.patch.
  * Add repair-git-unable-to-detect-address.patch (Autopkgtest).
  * Add Bug-Submit field to d/upstream/metadata.

  [ Sean Whitton ]
  * Team upload.
  * override_dh_elpa_test: Export EMACS_INHIBIT_AUTOMATIC_NATIVE_COMPILATION=t
    (Closes: #1020153).
    - Add build-dep on emacs-nox|emacs >= 1:28.2+1-9.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 24 Dec 2022 12:23:59 -0700

magit (3.3.0-1) unstable; urgency=medium

  * New upstream version

 -- Rémi Vanicat <vanicat@debian.org>  Wed, 06 Oct 2021 14:58:32 +0200

magit (3.2.1-2) unstable; urgency=medium

  * Team upload.
  * Source-only upload for testing migration.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 26 Aug 2021 14:07:37 -0700

magit (3.2.1-1) unstable; urgency=medium

  [ Rémi Vanicat ]
  * New upstream version
  * Adapt watch file
  * Adapt patches
    - 0002-Do-not-require-async.patch not needed anymore
    - 0005-Update-version-and-require-of-git-commit.patch: most is
      integrated upstream, the rest in:
      0004-Signal-in-the-documentation-there-are-Debian-patches.patch
  * Add an elpa-magit-section package.
    It has been separated upstream.

  [ Matteo F. Vescovi ]
  * New upstream version 3.2.1
    - debian/patches/: #0004 refreshed against v3.2.1
  * debian/control:
    - debhelper bump 12 -> 13
    - RRR set
    - S-V bump 4.1.4 -> 4.6.0 (no changes needed)
  * debian/watch: version bump 3 -> 4

 -- Rémi Vanicat <vanicat@debian.org>  Sat, 21 Aug 2021 14:48:14 +0200
