=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

export DEB_VERSION_UPSTREAM

# This is needed for running correctly the test in auto-builder
export GIT_AUTHOR_NAME = "Magit testeur"
export GIT_COMMITTER_NAME = "Magit committer"
export GIT_AUTHOR_EMAIL = "magit-testeur@example.org"
export GIT_COMMITTER_EMAIL = "magit-testeur@example.org"
export LC_ALL = C.UTF-8

%:
	dh $@ --with elpa

override_dh_auto_build:
	make info
	@echo do not run make

override_dh_auto_install:
	@echo do not run make install

override_dh_elpa_test:
	EMACS_INHIBIT_AUTOMATIC_NATIVE_COMPILATION=t make test

override_dh_clean:
	dh_clean
