=== debian/watch ===
version=4
    https://github.com/magit/magit/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
